{$R MJ.Res}
Program mj;

Uses Objects, WinTypes, WinProcs, MahJongg, mjDraw, mjWindow,
     mjDefs, Strings, GrTools, MjDlgs, mjBoss, OWindows;

const
    cm_ActivatePlayer = 900;

    APPNAME = 'MAHJONGG';


TYPE
  TMyApplication = Object(TApplication)
    Procedure InitMainWindow; Virtual;
  END;

  PMyWindow = ^TMyWindow;
  TMyWindow = Object(TWindow)
    Running,
    BreakFlag : Boolean;
    PlayerWindow: PPlayerWindow;
    TimerCount, MaxTime: Integer;
    Constructor Init(AParent: PWindowsObject; ATitle: PChar);
    procedure   SetupWindow; virtual;
    procedure   LoadConfig; virtual;
    procedure   SaveConfig; virtual;
    Procedure   DoMove; Virtual;
    Procedure   cmBoss(VAR MSG: TMessage); Virtual cm_First+cm_Boss;
    Procedure   cmNextMove(VAR MSG: TMessage); Virtual cm_First+cm_NextMove;
    Procedure   cmBack(VAR MSG: TMessage); Virtual cm_First+cm_Back;
    Procedure   cmOptions(VAR MSG: TMessage); Virtual cm_First+cm_Options;
    Procedure   cmShowHS(VAR MSG: TMessage); Virtual cm_First+cm_ShowHS;
    Procedure   cmActivatePlayer(VAR MSG: TMessage); Virtual cm_First+cm_ActivatePlayer;
    Procedure   cmQuit(VAR MSG: TMessage); Virtual cm_First+cm_Quit;
    Procedure   cmInfo(VAR MSG: TMessage); Virtual cm_First+cm_Info;
    procedure   WMTimer(var Msg: TMessage);
      virtual   wm_First + wm_Timer;
    procedure   TimerTick; virtual;
    procedure   Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    Function    CanClose: Boolean; Virtual;
  END;

Constructor TMyWindow.Init(AParent: PWindowsObject; ATitle: PChar);
BEGIN
  TimerActive := True;
  TWindow.Init(AParent, ATitle);
  Attr.X    := 0;
  Attr.Y    := 0;
  Attr.W    := 640;
  Attr.H    := 480;
  Attr.W    := 1024;
  Attr.H    := 768;
  Attr.Menu := LoadMenu(HInstance, 'Menu_Action');
  Running   := False;
END;


procedure TMyWindow.SetupWindow;
 var
    Result: Integer;
begin
  Result := IDRetry;
  while (SetTimer(hWIndow, 0, 50, nil) = 0) and (Result = IDRetry) do
    Result := MessageBox(GetFocus,'Could not Create Timer', 'GDIDemo',
      mb_RetryCancel);
  if Result = IDCancel then PostQuitMessage(0);

  LoadConfig;

  PlayerWindow := New(PPlayerWindow, Init(@Self, TheGame.Player[0]));
  PlayerWindow^.Create;
  PostMessage(HWindow, WM_Command, cm_ActivatePlayer, 0);


  TimerCount := 0;
  MaxTime := TicksForThrow;
  TimerActive := False;
end;

procedure TMyWindow.LoadConfig;
 var
    p1,p2,p3,IniFile: array[0..255] of Char;
    i, Dummy: Integer;
    s: String;
function CLoad(Name, Default: String): String;
begin
  StrPCopy(p1, Name);
  StrPCopy(p2, Default);
  GetPrivateProfileString(APPNAME,p1,p2,p3,255,IniFile);
  CLoad := StrPas(p3);
end;
begin
  GetWindowsDirectory(IniFile,255);
  StrCat(IniFile,'\PASCAL.INI');

  for i := 1 to 10 do
  begin
    s := 'HighScore'+NToS(i);
    Highscore[i].Name := CLoad(s+'_Name',' -');
    val( CLoad(s+'_Punkte',    '0'), Highscore[i].Punkte, Dummy);
    val( CLoad(s+'_Spiele',    '0'), Highscore[i].Spiele, Dummy);
  end;
  TheGame.Player[0]^.Name := CLoad('SpielerName','Spieler1');
  val( CLoad('ZeitZumRufen', '100'), TicksForDraw, Dummy);
  val( CLoad('ZeitZumZiehen','20'), TicksForThrow, Dummy);
  val( CLoad('Ton', '2'), Ton, Dummy);
  AusteilenAn := CLoad('Austeilen', 'An')='An';
end;


procedure TMyWindow.SaveConfig;
 var
    p1, p2, IniFile: array[0..255] of Char;
    i: Integer;
    s: String;
 procedure CSave(Name, Txt: String);
 begin
   StrPCopy(p1, Name);
   StrPCopy(p2, Txt);
   WritePrivateProfileString(APPNAME,p1,p2,IniFile);
 end;
begin
  GetWindowsDirectory(IniFile,240);
  StrCat(IniFile,'\PASCAL.INI');

  for i := 1 to 10 do
  begin
    s := 'HighScore'+NToS(i);
    CSave(s+'_Name', Highscore[i].Name);
    CSave(s+'_Punkte', NToS(Highscore[i].Punkte));
    CSave(s+'_Spiele', NToS(Highscore[i].Spiele));
  end;

  CSave('SpielerName', TheGame.Player[0]^.Name);

  CSave('ZeitZumZiehen', NToS(TicksForThrow));
  CSave('ZeitZumRufen', NToS(TicksForDraw));
  CSave('Ton', NToS(Ton));
  if AusteilenAn then CSave('Austeilen', 'An')
                 else CSave('Austeilen', 'Aus');
end;


Procedure TMyWindow.DoMove;
 var
    a: array[0..255] of char;
begin
  InfoTxt := '';
  TimerCount := 0;
  TheGame.DoMove;
  if InfoTxt = '' then
    MaxTime := TicksForThrow
  else
    MaxTime := TicksForDraw;
  StrPCopy(a, InfoTxt);
  SetWindowText(PlayerWindow^.HWindow, a);
  InvalidateRect(HWindow, nil, False);
end;


Procedure TMyWindow.cmBoss(VAR MSG: TMessage);
 var
    OldTA: Boolean;
BEGIN
  OldTA := TimerActive;
  TimerActive := True;
  ShowWindow(HWindow, sw_Hide);
  ShowWindow(PlayerWindow^.HWindow, sw_Hide);
  wait('&MJ');
  ShowWindow(HWindow, sw_Show);
  ShowWindow(PlayerWindow^.HWindow, sw_Show);
  TimerActive := OldTA;
END;

Procedure TMyWindow.cmNextMove(VAR MSG: TMessage);
BEGIN
  if not TimerActive then
  begin
    TimerActive := True; 
    DoMove;
    TimerActive := False;
  end;
END;

Procedure TMyWindow.cmBack(VAR MSG: TMessage);
 var
    a: array[0..255] of char;
BEGIN
  if not TimerActive then
  begin
    TimerActive := True; 
    TheGame.LoadGame;
    StrPCopy(a, InfoTxt);
    SetWindowText(PlayerWindow^.HWindow, a);
    InvalidateRect(HWindow, nil, False);
    TimerActive := False;
{    PostMessage(HWindow, WM_Command, cm_NextMove, 0);}
  end;
END;

Procedure TMyWindow.cmOptions(VAR MSG: TMessage);
 var
    Buffer: TOptionsInfo;
    i: Integer; 
BEGIN
  if not TimerActive then
  begin
    TimerActive := True; 

    Buffer.b[1] := Ton=0;
    Buffer.b[2] := Ton=1;
    Buffer.b[3] := Ton=2;
    Buffer.b[4] := AusteilenAn;
    Buffer.b[5] := False;
    Buffer.BarInfos[1].n := TicksForThrow div 20;
    Buffer.BarInfos[1].nMin := 0;
    Buffer.BarInfos[1].nMax := 60;
    Buffer.BarInfos[1].Title := 'Zeit zum Ziehen:';
    Buffer.BarInfos[2].n := TicksForDraw div 20;
    Buffer.BarInfos[2].nMin := 0;
    Buffer.BarInfos[2].nMax := 60;
    Buffer.BarInfos[2].Title := 'Zeit zum Rufen:';
    Buffer.s := TheGame.Player[0]^.Name;
    if Application^.ExecDialog(New(POptionsDialog, Init(@Buffer))) = ID_OK then
    begin
      if Buffer.b[1] then
        Ton := 0;
      if Buffer.b[2] then
        Ton := 1;
      if Buffer.b[3] then
        Ton := 2;
      AusteilenAn := Buffer.b[4];
      TicksForThrow := Buffer.BarInfos[1].n*20;
      TicksForDraw := Buffer.BarInfos[2].n*20;
      TheGame.Player[0]^.Name := Buffer.s;
      if Buffer.b[5] then
      begin
        for i:=1 to 10 do
        begin
          Highscore[i].Name := ' -';
          Highscore[i].Punkte := 0;
          Highscore[i].Spiele := 0;
        end;
      end;
    end;
    TimerActive := False;
  end;
END;


Procedure TMyWindow.cmShowHS(VAR MSG: TMessage);
begin
  if not TimerActive then
  begin
    TimerActive := True;
    TheGame.ShowHighscore;
    TimerActive := False;
  end;
end;


Procedure TMyWindow.cmActivatePlayer(VAR MSG: TMessage);
BEGIN
  SetActiveWindow(PlayerWindow^.HWindow);
END;

Procedure TMyWindow.cmQuit(VAR MSG: TMessage);
BEGIN
  CloseWindow;
END;

Procedure TMyWindow.cmInfo(VAR MSG: TMessage);
BEGIN
  MessageBox(HWindow,'MAH JONGG  -  Version 0.5'+#13#10
             +#13#10
             +'Das Programm darf frei weitergegeben'+#13#10
             +'werden, Anregungen sind erwnscht.'+#13#10
             +'Viel Spa!'+#13#10
             +#13#10
             +'(c) 1994 Ferenc Kurucz'+#13#10
             +'               Darmstdter Strae 9'+#13#10
             +'               64673 Zwingenberg','Info', mb_IconInformation+mb_OK)
END;


procedure TMyWindow.WMTimer(var Msg: TMessage);
begin
  if not TimerActive then
  begin 
    TimerActive := True;
{
    if (TimerCount<=21) and (InfoTxt<>'') then
    begin
      FlashWindow(PlayerWindow^.HWindow, not Odd(TimerCount div 7));
    end;
}
    if TimerCount>=MaxTime then
    begin
      TimerCount := 0;
      TimerTick;
    end
    else
      TimerCount := TimerCount+1;
    TimerActive := False;
  end;
end;


procedure TMyWindow.TimerTick;
begin
  if (not TheGame.Finished) and
         ((TheGame.CurrentPlayer<>0) or
          (TheGame.WaitForCall) or
          (TheGame.Austeilen<>0)) then
  begin
    if TheGame.Player[0]^.ThisCall=-1 then
      TheGame.Player[0]^.ThisCall:=0;
    DoMove;
    InvalidateRect(HWindow, nil, False);
  end;
end;


procedure ShowPlayer(ADC: HDC; Player: PPlayer; X, Y: Integer);
 var
    XPos, YPos, i, Mode: integer;
begin
  XPos := 0;
  YPos := 0;
  Mode := NoTile;
  for i := 0 to Player^.Open.Count-1 do
  begin
    if Player^.Open.GetTile(i)=NoTile then
    begin
      Mode := NoTile;
      if XPos>0 then
      begin
        XPos := 0;
        YPos := YPos+28;
      end;
    end
    else
    if Player^.Open.GetTile(i)=HalbVerdeckt then
      Mode := HalbVerdeckt
    else
    if Player^.Open.GetTile(i)=Verdeckt then
      Mode := Verdeckt
    else
    begin
      if (Mode=Verdeckt) then
        DrawVOpenTile(ADC, 5+X+XPos*26, 3+Y+YPos, Player^.Open.GetTile(i))
      else if (Mode=HalbVerdeckt) then
        DrawHVOpenTile(ADC, 5+X+XPos*26, Y+YPos)
      else
        DrawOpenTile(ADC, 5+X+XPos*26, Y+YPos, Player^.Open.GetTile(i));
      Mode := NoTile;
      XPos := XPos+1;
      if XPos>=4 then
      begin
        XPos := 0;
        YPos := YPos+28;
      end;
    end;
  end;
end;


procedure ShowHand(ADC: HDC; Player: PPlayer; X, Y: Integer);
 var
    XPos, YPos, i, Mode: integer;
begin
  XPos := 0;
  YPos := 0;
  Mode := NoTile;
  for i := 0 to Player^.Hand.Count-1 do
  begin
    if Player^.Hand.GetTile(i)=NoTile then
    begin
      Mode := NoTile;
      if XPos>0 then
      begin
        XPos := 0;
        YPos := YPos+28;
      end;
    end
    else
    if Player^.Hand.GetTile(i)=HalbVerdeckt then
      Mode := HalbVerdeckt
    else
    if Player^.Hand.GetTile(i)=Verdeckt then
      Mode := Verdeckt
    else
    begin
      if (Mode=Verdeckt) then
        DrawVOpenTile(ADC, 5+X+XPos*26, 3+Y+YPos, Player^.Hand.GetTile(i))
      else if (Mode=HalbVerdeckt) then
        DrawHVOpenTile(ADC, 5+X+XPos*26, Y+YPos)
      else
        DrawOpenTile(ADC, 5+X+XPos*26, Y+YPos, Player^.Hand.GetTile(i));
      Mode := NoTile;
      XPos := XPos+1;
      if XPos>=4 then
      begin
        XPos := 0;
        YPos := YPos+28;
      end;
    end;
  end;
end;


procedure TMyWindow.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
 var Anz, i, j, k, R: Integer;
     X, Y: Integer;
     MemDC: HDC;
     OldBmp: HBitmap;
const
  OrgX = 108;
  OrgY = 1;
  SizeX = 20;
  SizeY = 20;
begin
 { TWindow.Paint(PaintDC, PaintInfo);}

  MemDC := CreateCompatibleDC(PaintDC);
  OldBMP := CreateCompatibleBitmap(PaintDC, 640, 450);
  OldBMP := SelectObject(MemDC, OldBMP);

  BitBlt(MemDC, 0, 0, 640, 450, MemDC, 0, 0, Whiteness);

  ShowPlayer(MemDC, TheGame.Player[1],   -3, 220);
  if TheGame.Player[0]^.name='Mogel' then
    ShowHand(MemDC, TheGame.Player[1],   -3,  0);
  ShowPlayer(MemDC, TheGame.Player[2], 530,   3);
  ShowPlayer(MemDC, TheGame.Player[3], 530, 220);

  for i := 17 downto 0 do
  begin
    for j := 0 to TheGame.GetWallHeight(1, 17-i)-1  do
      DrawHBack(MemDC,  OrgX+5-5*j, OrgY+5*j+25+i*SizeY);
  end;
  for i := 0 to 17 do
  begin
    for j := 0 to TheGame.GetWallHeight(2, i)-1 do
      DrawVBack(MemDC, OrgX+34-5*j+i*SizeX, OrgY+5*j);
  end;
  for i := 0 to 17 do
  begin
    for j := 0 to TheGame.GetWallHeight(0, 17-i)-1 do
      DrawVBack(MemDC, OrgX+34-5*j+i*SizeX, OrgY+5*j+25+SizeY*18);
  end;
  for i := 17 downto 0 do
  begin
    for j := 0 to TheGame.GetWallHeight(3, i)-1 do
      DrawHBack(MemDC, OrgX-5*j+34+SizeX*18, OrgY+5*j+25+i*SizeY);
  end;

  Anz := TheGame.Open.Count-1;
  j := SizeX*15 div 22;
  for Y := Anz div j downto 0 do
  begin
    for X := 0 to j-1 do
    begin
      i := Y*j+X;
      if i<=Anz then
        DrawTile(MemDC, OrgX+65+X*22, OrgY+65+Y*28, TheGame.Open.GetTile(i));
    end;
  end;


  R := TheGame.East;
  k := TheGame.CurrentPlayer;
  DrawScheibe(MemDC, SizeX*10+OrgX, SizeY*18+4+OrgY, (4-R) mod 4, k=0);
  DrawScheibe(MemDC,  40+OrgX, SizeY*10+4+OrgY, (5-R) mod 4, k=1);
  DrawScheibe(MemDC, SizeX*10+OrgX,  39+OrgY, (6-R) mod 4, k=2);
  DrawScheibe(MemDC, SizeX*18+4+OrgX, SizeY*10+4+OrgY, (7-R) mod 4, k=3);

{
  BitBlt(PaintDC, 0, 0, 640, 450, MemDC, 0, 0, SrcCopy);
}
{
  SetStretchBltMode(PaintDC, 4);
  StretchBlt(PaintDC, 0, 0, 1024, 720, MemDC, 0, 0, 640, 450, SrcCopy);
}
  SetStretchBltMode(PaintDC, 4);  {HALFTONE}
  StretchBlt(PaintDC, 0, 0, 1024, 720, MemDC, 0, 0, 640, 450, SrcCopy);

  DeleteObject(SelectObject(MemDC, OldBMP));
  DeleteDC(MemDC);

  PlayerWindow^.RedrawIfChanged;
end;

Function TMyWindow.CanClose: Boolean;
BEGIN
  CanClose := Not Running;
  BreakFlag := True;
  IF Running then
    PostMessage(HWindow, wm_Close, 0, 0)
  else
  begin
    SaveConfig;
    Dispose(PlayerWindow, Done);
  end;
END;

Procedure TMyApplication.InitMainWindow;
BEGIN
  MainWindow := New(PMyWindow, Init(NIL, 'The Real MahJongg'));
  HAccTable := LoadAccelerators(HInstance, 'ACCELERATORS_MJ');
END;

 VAR
    MeinProgramm : TMyApplication;

BEGIN
  MeinProgramm.Init('');
  MeinProgramm.Run;
  MeinProgramm.Done;
END.



