unit mjdlgs;

interface

uses Objects, WinTypes, Strings, GrTools, NewBar, ODialogs, OWindows;

type
  POptionsInfo = ^TOptionsInfo;
  TOptionsInfo = record
                   b: array[1..5] of Boolean;
                   BarInfos: array[1..2] of TBarInfo;
                   s: String;
                 end;
                   
  PWaitInfo = ^TWaitInfo;
  TWaitInfo = record
                n: Integer;
              end;
                   


  POptionsDialog = ^TOptionsDialog;
  TOptionsDialog = Object(TDialog)
    Buffer: POptionsInfo;
    constructor Init(ABuffer: POptionsInfo);
    procedure SetupWindow; virtual;
    procedure Ok(var Msg: TMessage); virtual id_First + id_OK;
  end;

  PWaitDialog = ^TWaitDialog;
  TWaitDialog = Object(TDialog)
    Buffer: PWaitInfo;
    constructor Init(ABuffer: PWaitInfo);
    procedure SetupWindow; virtual;
    procedure Ok(var Msg: TMessage); virtual id_First + id_OK;
  end;



implementation

{----------- TOPTIONSDIALOG ----------------}

constructor TOptionsDialog.Init(ABuffer: POptionsInfo);
 var
    dummy: Pointer;
begin
  TDialog.Init(Application^.MainWindow, 'OPTIONS_DIALOG');
  Buffer := ABuffer;
  dummy := New(PNewBar, InitResource(@Self, 131, @Buffer^.BarInfos[1]));
  dummy := New(PNewBar, InitResource(@Self, 132, @Buffer^.BarInfos[2]));
end;

procedure TOptionsDialog.SetupWindow; 
 var
    a: array[0..255] of char;
    s: String;
    i: Integer;    
begin
  TDialog.SetupWindow;

  strpcopy(a, Buffer^.s);
  SendDlgItemMsg(121, wm_SetText, length(s), longint(@a));

  for i := 1 to 5 do
    if Buffer^.b[i] then
      SendDlgItemMsg(110+i, bm_SetCheck, 1, 0)
    else
      SendDlgItemMsg(110+i, bm_SetCheck, 0, 0);
end;

procedure TOptionsDialog.Ok(var Msg: TMessage); 
 var
    a: array[0..80] of char;
    VCode: Word;
    i: Integer;
begin
  SendDlgItemMsg(121, wm_gettext, 80, Longint(@a));
  Buffer^.s := StrPas(a);

  for i := 1 to 5 do
    Buffer^.b[i] := (SendDlgItemMsg(110+i, bm_GetCheck, 0, 0)=1);

  TDialog.OK(Msg);
end;


{----------- TWAITDIALOG ----------------}

constructor TWaitDialog.Init(ABuffer: PWaitInfo);
begin
  TDialog.Init(Application^.MainWindow, 'WAIT_DIALOG');
  Buffer := ABuffer;
end;

procedure TWaitDialog.SetupWindow;
 var
    a: array[0..255] of char;
    s: String;
    i: Integer;    
begin
  TDialog.SetupWindow;
  SendDlgItemMsg(100, bm_SetCheck, 1, 0);
end;

procedure TWaitDialog.Ok(var Msg: TMessage); 
 var
    i: Integer;
begin
  Buffer^.n := 0;
  for i := 1 to 4 do
    if SendDlgItemMsg(100+i, bm_getCheck, 0, 0)=1 then
      Buffer^.n := i;
  TDialog.OK(Msg);
end;



end.