unit newBar;

interface

uses Objects, WinTypes, WinProcs, Strings, ODialogs, OWindows;

type
  PBarInfo = ^TBarInfo;
  TBarInfo = record
               n, nMin, nMax: Integer;
               Title: String;
             end;
                
  PNewBar = ^TNewBar;
  TNewBar = Object(TControl)
    n, nMin, nMax,
    X1, X2, Y, YText, dX: Integer;
    rPos: Real;
    GetMove: Boolean;
    BarInfo: PBarInfo;
    constructor InitResource(AParent: PWindowsObject; ResourceID: Word; BarInf: PBarInfo);
    procedure   WMLButtonDown(var Msg: TMessage);
                virtual wm_First + wm_LButtonDown;
    procedure   WMMouseMove(var Msg: TMessage);
                virtual wm_First + wm_MouseMove;
    procedure   WMLButtonUp(var Msg: TMessage);
                virtual wm_First + wm_LButtonUp;
    procedure   WMPaint(var Msg: TMessage);
                virtual wm_First + wm_Paint;
  end;


implementation

{----------- TNEWBAR ----------------}

constructor TNewBar.InitResource(AParent: PWindowsObject; ResourceID: Word; BarInf: PBarInfo);
begin
  TControl.InitResource(AParent, ResourceID);
  BarInfo := BarInf;
  n := BarInfo^.n;
  nMin := BarInfo^.nMin;
  nMax := BarInfo^.nMax;
  rPos := (n-nMin)/(nMax-nMin);
  X1 := 0;
  X2 := 10;
  Y := -1;
  GetMove := False;
end;



procedure TNewBar.WMPaint(var Msg: TMessage);
 var
    ADC: HDC;
    ABrush: HBrush;
    PaintInfo: TPaintStruct;
    XPos: Integer;
    a: array[0..80] of char;
    s: string[80];
    r: TRect;
begin
  ADC := BeginPaint(HWindow, PaintInfo);
  
  ABrush := CreateSolidBrush(GetSysColor(color_Window));

  if Y=-1 then
  begin
    YText := PaintInfo.rcPaint.Top+1;
    Y := PaintInfo.rcPaint.Bottom - 8;
    X1 := PaintInfo.rcPaint.Left+1;
    X2 := PaintInfo.rcPaint.Right-1;
    dX := X2-X1-9;
  end;

  XPos := X1+4+trunc(rPos*dX+0.5);

  {Bild lschen}
  SetRect(r, X1-1, YText-1, X2+1, Y+7+1);
  FillRect(ADC, r, ABrush);

  {Schlitz malen}
  SetRect(r, X1, Y-1, X2, Y+2);
  FrameRect(ADC, r, GetStockObject(Black_Brush));

  {Marker malen}
  SetRect(r, XPos-3, Y-7, XPos+4, Y+7);
  FrameRect(ADC, r, GetStockObject(Black_Brush));
  SetRect(r, XPos-4, Y-6, XPos+5, Y+6);
  FrameRect(ADC, r, GetStockObject(Black_Brush));
  SetRect(r, XPos-3, Y-6, XPos+4, Y+6);
  FillRect(ADC, r, GetStockObject(Gray_Brush));

  {Nummer ausgeben}
  SetTextAlign(ADC, ta_Top+ta_Right+ta_NoUpdateCP);
  SetBKMode(ADC, transparent);
  n := nMin+trunc(rPos*(nMax-nMin)+0.5);
  BarInfo^.n := n;
  Str(n,s);
  StrPCopy(a,s);
  TextOut(ADC, X2, YText, a, length(s));

  {Titel ausgeben}
  SetTextAlign(ADC, ta_Top+ta_Left+ta_NoUpdateCP);
  s := BarInfo^.Title;
  StrPCopy(a,s);
  TextOut(ADC, X1, YText, a, length(s));

  EndPaint(HWindow, PaintInfo);
  DeleteObject(ABrush);

end;


procedure TNewBar.WMLButtonDown(var Msg: TMessage);
 var
    MX, MY, XPos: Integer;
begin
  MX := Msg.LParamLo;
  MY := Msg.LParamHi;
  XPos := X1+4+trunc(rPos*dX+0.5);
  if (MY>=Y-7) and (MY<=Y+7) and (MX>=X1) and (MX<=X2) then
  begin
    rPos := (MX-X1-4)/dX;
    if rPos<0 then
      rPos := 0;
    if rPos>1 then
      rPos := 1;
    SetCapture(HWindow);
    GetMove := True;
    InvalidateRect(HWindow, nil, true);
  end;
  DefWndProc(Msg);
end;


procedure TNewBar.WMMouseMove(var Msg: TMessage);
 var
    MX, MY, XPos: Integer;
begin
  if GetMove then
  begin
    MX := Integer(Msg.LParamLo);
    MY := Integer(Msg.LParamHi);
    rPos := (MX-X1-4)/dX;
    if rPos<0 then
      rPos := 0;
    if rPos>1 then
      rPos := 1;
    InvalidateRect(HWindow, nil, true);
  end;
  DefWndProc(Msg);
end;


procedure TNewBar.WMLButtonUp(var Msg: TMessage);
 var
    MX, MY, XPos: Integer;
begin
  if GetMove then
  begin
    MX := Integer(Msg.LParamLo);
    MY := Integer(Msg.LParamHi);
    rPos := (MX-X1-4)/dX;
    if rPos<0 then
      rPos := 0;
    if rPos>1 then
      rPos := 1;
    releaseCapture;
    GetMove := False;
    InvalidateRect(HWindow, nil, true);
  end;
  DefWndProc(Msg);
end;

{**********
Einbinden am Ende der Init-Methode des Dialogs: 
    dummy := New(PNewBar, InitResource(@Self, 111, @Buffer^.BarInfo));
**********}

end.